
// USB-TG44ADlg.cpp : implementation file
//

#include "stdafx.h"
#include "USB-TG44A.h"
#include "USB-TG44ADlg.h"
#include "afxdialogex.h"
#include "Utils.h"

//#include ".\Misc\RegistryUtil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CUSBTG44ADlg dialog


CUSBTG44ADlg::CUSBTG44ADlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CUSBTG44ADlg::IDD, pParent)
	, m_CurrentFrequency(_T(""))
	, m_CurrentAmplitude(_T(""))
	, m_SingletoneFrequency(_T(""))
	, m_SingletoneAmplitude(_T(""))
	, m_FreqsweepStartFrequency(_T(""))
	, m_FreqsweepStopFrequency(_T(""))
	, m_FreqsweepStepFrequency(_T(""))
	, m_FreqsweepStepTime(0)
	, m_FreqsweepAmplitude(_T(""))
	, m_FreqsweepStart(FALSE)
	, m_FreqsweepLoop(FALSE)
	, m_AmplsweepStartAmplitude(_T(""))
	, m_AmplsweepStopAmplitude(_T(""))
	, m_AmplsweepStepAmplitude(_T(""))
	, m_AmplsweepStepTime(0)
	, m_AmplsweepFrequency(_T(""))
	, m_AmplsweepStart(FALSE)
	, m_AmplsweepLoop(FALSE)
	, m_FilesweepFilename(_T(""))
	, m_FilesweepStepTime(0)
	, m_FilesweepStart(FALSE)
	, m_FilesweepLoop(FALSE)
	, m_TimerId(NULL)
	, m_FreqAmpls()
	, m_FreqAmplsI(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
//	gLog.SetOutputMode(true, true, false);
}

void CUSBTG44ADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SINGLETONE_FREQUENCY, m_SingletoneFrequency);
	DDX_Text(pDX, IDC_SINGLETONE_AMPLITUDE, m_SingletoneAmplitude);
	DDX_Text(pDX, IDC_FREQSWEEP_START_FREQUENCY, m_FreqsweepStartFrequency);
	DDX_Text(pDX, IDC_FREQSWEEP_STOP_FREQUENCY, m_FreqsweepStopFrequency);
	DDX_Text(pDX, IDC_FREQSWEEP_STEP_FREQUENCY, m_FreqsweepStepFrequency);
	DDX_Text(pDX, IDC_FREQSWEEP_STEP_TIME, m_FreqsweepStepTime);
	DDX_Text(pDX, IDC_FREQSWEEP_AMPLITUDE, m_FreqsweepAmplitude);
	DDX_Check(pDX, IDC_FREQSWEEP_START, m_FreqsweepStart);
	DDX_Check(pDX, IDC_FREQSWEEP_LOOP, m_FreqsweepLoop);
	DDX_Text(pDX, IDC_CURRENT_FREQUENCY, m_CurrentFrequency);
	DDX_Text(pDX, IDC_AMPLSWEEP_START_AMPLITUDE, m_AmplsweepStartAmplitude);
	DDX_Text(pDX, IDC_AMPLSWEEP_STOP_AMPLITUDE, m_AmplsweepStopAmplitude);
	DDX_Text(pDX, IDC_AMPLSWEEP_STEP_AMPLITUDE, m_AmplsweepStepAmplitude);
	DDX_Text(pDX, IDC_AMPLSWEEP_STEP_TIME, m_AmplsweepStepTime);
	DDX_Text(pDX, IDC_AMPLSWEEP_FREQUENCY, m_AmplsweepFrequency);
	DDX_Check(pDX, IDC_AMPLSWEEP_START, m_AmplsweepStart);
	DDX_Check(pDX, IDC_AMPLSWEEP_LOOP, m_AmplsweepLoop);
	DDX_Text(pDX, IDC_CURRENT_AMPLITUDE, m_CurrentAmplitude);
	DDX_Text(pDX, IDC_FILESWEEP_FILENAME, m_FilesweepFilename);
	DDX_Text(pDX, IDC_FILESWEEP_STEP_TIME, m_FilesweepStepTime);
	DDX_Check(pDX, IDC_FILESWEEP_LOOP, m_FilesweepLoop);
	DDX_Check(pDX, IDC_FILESWEEP_START, m_FilesweepStart);
}

BEGIN_MESSAGE_MAP(CUSBTG44ADlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SINGLETONE_APPLY, &CUSBTG44ADlg::OnBnClickedSingletoneApply)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_FREQSWEEP_START, &CUSBTG44ADlg::OnBnClickedFreqsweepStart)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_AMPLSWEEP_START, &CUSBTG44ADlg::OnBnClickedAmplsweepStart)
	ON_BN_CLICKED(IDC_FILESWEEP_OPEN, &CUSBTG44ADlg::OnBnClickedFilesweepOpen)
	ON_BN_CLICKED(IDC_FILESWEEP_START, &CUSBTG44ADlg::OnBnClickedFilesweepStart)
END_MESSAGE_MAP()


// CUSBTG44ADlg message handlers

BOOL CUSBTG44ADlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	InitControls();
	
	SetFreqAmplitude(_T("OnInitDialog()"), ToHz(m_SingletoneFrequency), ToInt(m_SingletoneAmplitude));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUSBTG44ADlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBTG44ADlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBTG44ADlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CUSBTG44ADlg::OnClose()
{
	if (m_TimerId) {
		KillTimer(m_TimerId);
		m_TimerId = NULL;
	}

	SaveControls();

	CDialogEx::OnClose();
}

void CUSBTG44ADlg::OnTimer(UINT_PTR nIDEvent)
{
	switch(nIDEvent) {
		case scFreqsweepTimerId:
			FreqsweepOnTimer();
			break;
		case scAmplsweepTimerId:
			AmplsweepOnTimer();
			break;
		case scFilesweepTimerId:
			FilesweepOnTimer();
			break;
	}

	CDialogEx::OnTimer(nIDEvent);
}

void CUSBTG44ADlg::OnBnClickedSingletoneApply()
{
	UpdateData();

//	ReadCalData(_T("OnBnClickedSingletoneApply()"));
	SetFreqAmplitude(_T("OnBnClickedSingletoneApply()"), ToHz(m_SingletoneFrequency), ToInt(m_SingletoneAmplitude));

	m_CurrentAmplitude = m_SingletoneAmplitude;
	m_CurrentFrequency = m_SingletoneFrequency;
	UpdateData(FALSE);
}

void CUSBTG44ADlg::OnBnClickedFreqsweepStart()
{
	UpdateData();

	if (m_FreqsweepStart) {
		m_CurrentFrequency = m_FreqsweepStartFrequency;
		SetFreqAmplitude(_T("OnBnClickedFreqsweepStart()"), ToHz(m_FreqsweepStartFrequency), ToInt(m_FreqsweepAmplitude));

		m_TimerId = SetTimer(scFreqsweepTimerId, m_FreqsweepStepTime, NULL);
		
		m_CurrentAmplitude = m_FreqsweepAmplitude;
		SetDlgItemText(IDC_FREQSWEEP_START, _T("Stop"));
		GetDlgItem(IDC_SINGLETONE_APPLY)->EnableWindow(FALSE);
		GetDlgItem(IDC_AMPLSWEEP_START)->EnableWindow(FALSE);
		GetDlgItem(IDC_FILESWEEP_START)->EnableWindow(FALSE);
		UpdateData(FALSE);
	}
	else {
		FreqsweepStop();
	}
}

void CUSBTG44ADlg::OnBnClickedAmplsweepStart()
{
	UpdateData();

	if (m_AmplsweepStart) {
		m_CurrentAmplitude = m_AmplsweepStartAmplitude;
		SetFreqAmplitude(_T("OnBnClickedAmplsweepStart()"), ToHz(m_AmplsweepFrequency), ToInt(m_AmplsweepStartAmplitude));

		m_TimerId = SetTimer(scAmplsweepTimerId, m_AmplsweepStepTime, NULL);
		
		m_CurrentFrequency = m_AmplsweepFrequency;
		SetDlgItemText(IDC_AMPLSWEEP_START, _T("Stop"));
		GetDlgItem(IDC_SINGLETONE_APPLY)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREQSWEEP_START)->EnableWindow(FALSE);
		GetDlgItem(IDC_FILESWEEP_START)->EnableWindow(FALSE);
		UpdateData(FALSE);
	}
	else {
		AmplsweepStop();
	}
}

void CUSBTG44ADlg::OnBnClickedFilesweepStart()
{
	UpdateData();

	ASSERT(FileWasLoaded());
	if(!FileWasLoaded()) {
		AfxMessageBox(_T("Please load the correct file"), MB_ICONSTOP);
		return;
	}

	if (m_FilesweepStart) {
		m_FreqAmplsI = 0;

		m_CurrentFrequency = m_FreqAmpls[m_FreqAmplsI].frequency;
		m_CurrentAmplitude = m_FreqAmpls[m_FreqAmplsI].amplitude;
		SetFreqAmplitude(_T("OnBnClickedFilesweepStart()"), ToHz(m_FreqAmpls[m_FreqAmplsI].frequency), ToInt(m_FreqAmpls[m_FreqAmplsI].amplitude));

		m_TimerId = SetTimer(scFilesweepTimerId, m_FilesweepStepTime, NULL);
		
		SetDlgItemText(IDC_FILESWEEP_START, _T("Stop"));
		GetDlgItem(IDC_SINGLETONE_APPLY)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREQSWEEP_START)->EnableWindow(FALSE);
		GetDlgItem(IDC_AMPLSWEEP_START)->EnableWindow(FALSE);
		UpdateData(FALSE);
	}
	else {
		FilesweepStop();
	}
}

void CUSBTG44ADlg::OnBnClickedFilesweepOpen()
{
	UpdateData();

	try {
		CFileDialog dlg(TRUE);
		if (dlg.DoModal() == IDOK) {
			if (LoadFile(dlg.GetPathName())) {
				m_FilesweepFilename = dlg.GetFileName();
				GetDlgItem(IDC_FILESWEEP_START)->EnableWindow(TRUE);
				UpdateData(FALSE);
			}
			else {
				AfxMessageBox(_T("Error loading the file"), MB_ICONSTOP);
			}
		}
	}
	catch(CException* e) {
		e->ReportError();
		e->Delete();
	}
}

void CUSBTG44ADlg::InitControls()
{
	m_SingletoneFrequency = theApp.GetProfileString(_T("Singletone"), _T("Frequency"), _T("500"));
	m_SingletoneAmplitude = theApp.GetProfileString(_T("Singletone"), _T("Amplitude"), _T("-10"));

	m_FreqsweepStartFrequency = theApp.GetProfileString(_T("Frequency sweep"), _T("Start Frequency"), _T("0.00001"));
	m_FreqsweepStopFrequency = theApp.GetProfileString(_T("Frequency sweep"), _T("Stop Frequency"), _T("4400"));
	m_FreqsweepStepFrequency = theApp.GetProfileString(_T("Frequency sweep"), _T("Step Frequency"), _T("0.000001"));
	m_FreqsweepStepTime = theApp.GetProfileInt(_T("Frequency sweep"), _T("Step Time"), 100);
	m_FreqsweepAmplitude = theApp.GetProfileString(_T("Frequency sweep"), _T("Amplitude"), _T("-10"));
	m_FreqsweepLoop = theApp.GetProfileInt(_T("Frequency sweep"), _T("Loop"), FALSE);

	m_AmplsweepStartAmplitude = theApp.GetProfileString(_T("Amplitude sweep"), _T("Start Amplitude"), _T("-30"));
	m_AmplsweepStopAmplitude = theApp.GetProfileString(_T("Amplitude sweep"), _T("Stop Amplitude"), _T("-10"));
	m_AmplsweepStepAmplitude = theApp.GetProfileString(_T("Amplitude sweep"), _T("Step Amplitude"), _T("1"));
	m_AmplsweepStepTime = theApp.GetProfileInt(_T("Amplitude sweep"), _T("Step Time"), 1000);
	m_AmplsweepFrequency = theApp.GetProfileString(_T("Amplitude sweep"), _T("Frequency"), _T("500"));
	m_AmplsweepLoop = theApp.GetProfileInt(_T("Amplitude sweep"), _T("Loop"), FALSE);

	m_CurrentFrequency = m_SingletoneFrequency;
	m_CurrentAmplitude = m_SingletoneAmplitude;
	
	m_FilesweepStepTime = theApp.GetProfileInt(_T("File sweep"), _T("Step Time"), 1000);;
	m_FilesweepLoop = theApp.GetProfileInt(_T("File sweep"), _T("Loop"), FALSE);


	GetDlgItem(IDC_FILESWEEP_START)->EnableWindow(FALSE);

	UpdateData(FALSE);
}

void CUSBTG44ADlg::SaveControls()
{
	UpdateData();

	theApp.WriteProfileString(_T("Singletone"), _T("Frequency"), m_SingletoneFrequency);
	theApp.WriteProfileString(_T("Singletone"), _T("Amplitude"), m_SingletoneAmplitude);

	theApp.WriteProfileString(_T("Frequency sweep"), _T("Start Frequency"), m_FreqsweepStartFrequency);
	theApp.WriteProfileString(_T("Frequency sweep"), _T("Stop Frequency"), m_FreqsweepStopFrequency);
	theApp.WriteProfileString(_T("Frequency sweep"), _T("Step Frequency"), m_FreqsweepStepFrequency);
	theApp.WriteProfileInt   (_T("Frequency sweep"), _T("Step Time"), m_FreqsweepStepTime);
	theApp.WriteProfileString(_T("Frequency sweep"), _T("Amplitude"), m_FreqsweepAmplitude);
	theApp.WriteProfileInt   (_T("Frequency sweep"), _T("Loop"), m_FreqsweepLoop);

	theApp.WriteProfileString(_T("Amplitude sweep"), _T("Start Amplitude"), m_AmplsweepStartAmplitude);
	theApp.WriteProfileString(_T("Amplitude sweep"), _T("Stop Amplitude"), m_AmplsweepStopAmplitude);
	theApp.WriteProfileString(_T("Amplitude sweep"), _T("Step Amplitude"), m_AmplsweepStepAmplitude);
	theApp.WriteProfileInt(_T("Amplitude sweep"), _T("Step Time"), m_AmplsweepStepTime);
	theApp.WriteProfileString(_T("Amplitude sweep"), _T("Frequency"), m_AmplsweepFrequency);
	theApp.WriteProfileInt(_T("Amplitude sweep"), _T("Loop"), m_AmplsweepLoop);

	theApp.WriteProfileInt(_T("File sweep"), _T("Step Time"), m_FilesweepStepTime);;
	theApp.WriteProfileInt(_T("File sweep"), _T("Loop"), m_FilesweepLoop);
}

// Call this function when click "Stop", or current value is equal to stop value.
// Use to kill timer and update interface.
void CUSBTG44ADlg::FreqsweepStop()
{
	KillTimer(m_TimerId);
	m_TimerId = NULL;
	SetDlgItemText(IDC_FREQSWEEP_START, _T("Start"));
	GetDlgItem(IDC_SINGLETONE_APPLY)->EnableWindow(TRUE);
	GetDlgItem(IDC_AMPLSWEEP_START)->EnableWindow(TRUE);
	if (FileWasLoaded()) {
		GetDlgItem(IDC_FILESWEEP_START)->EnableWindow(TRUE);
	}
}

void CUSBTG44ADlg::AmplsweepStop()
{
	KillTimer(m_TimerId);
	m_TimerId = NULL;
	SetDlgItemText(IDC_AMPLSWEEP_START, _T("Start"));
	GetDlgItem(IDC_SINGLETONE_APPLY)->EnableWindow(TRUE);
	GetDlgItem(IDC_FREQSWEEP_START)->EnableWindow(TRUE);
	if (FileWasLoaded()) {
		GetDlgItem(IDC_FILESWEEP_START)->EnableWindow(TRUE);
	}
}

void CUSBTG44ADlg::FilesweepStop()
{
	KillTimer(m_TimerId);
	m_TimerId = NULL;
	SetDlgItemText(IDC_FILESWEEP_START, _T("Start"));
	GetDlgItem(IDC_SINGLETONE_APPLY)->EnableWindow(TRUE);
	GetDlgItem(IDC_FREQSWEEP_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_AMPLSWEEP_START)->EnableWindow(TRUE);
}

void CUSBTG44ADlg::FreqsweepOnTimer()
{
	ASSERT(m_TimerId == scFreqsweepTimerId);

	UpdateData();

	LONGLONG cur = ToHz(m_CurrentFrequency);
	LONGLONG step = ToHz(m_FreqsweepStepFrequency);
	LONGLONG stop = ToHz(m_FreqsweepStopFrequency);
	
	cur += step;
	if (cur <= stop) {
		SetFreqAmplitude(_T("FreqsweepOnTimer()"), cur, ToInt(m_FreqsweepAmplitude));
		m_CurrentFrequency.Format(_T("%2f"), ToMHz(cur));
//		m_FreqsweepCurrentFrequency = ToString(ToMHz(cur));
		UpdateData(FALSE);
	}
	else {
		if (m_FreqsweepLoop) {
			m_CurrentFrequency = m_FreqsweepStartFrequency;
			cur = ToHz(m_CurrentFrequency);
			SetFreqAmplitude(_T("FreqsweepOnTimer()"), cur, ToInt(m_FreqsweepAmplitude));
			UpdateData(FALSE);
		}
		else {
			FreqsweepStop();
			m_FreqsweepStart = FALSE;
			UpdateData(FALSE);
		}
	}
}

void CUSBTG44ADlg::AmplsweepOnTimer()
{
	UpdateData();
	ASSERT(m_TimerId == scAmplsweepTimerId);

	int cur = ToInt(m_CurrentAmplitude);
	int step = ToInt(m_AmplsweepStepAmplitude);
	int stop = ToInt(m_AmplsweepStopAmplitude);
	
	cur += step;
	if (cur <= stop) {
		SetFreqAmplitude(_T("AmplsweepOnTimer()"), ToHz(m_AmplsweepFrequency), cur);
		m_CurrentAmplitude.Format(_T("%2d"), cur);
//		m_FreqsweepCurrentFrequency = ToString(ToMHz(cur));
		UpdateData(FALSE);
	}
	else {
		if (m_AmplsweepLoop) {
			m_CurrentAmplitude = m_AmplsweepStartAmplitude;
			cur = ToInt(m_CurrentAmplitude);
			SetFreqAmplitude(_T("AmplsweepOnTimer()"), ToHz(m_AmplsweepFrequency), cur);
			UpdateData(FALSE);
		}
		else {
			AmplsweepStop();
			m_AmplsweepStart = FALSE;
			UpdateData(FALSE);
		}
	}
}

void CUSBTG44ADlg::FilesweepOnTimer()
{
	UpdateData();
	ASSERT(m_TimerId == scFilesweepTimerId);

	m_FreqAmplsI++;
	if (m_FreqAmplsI >= m_FreqAmpls.size() && m_FilesweepLoop) {
		m_FreqAmplsI = 0;
	}

	if (m_FreqAmplsI < m_FreqAmpls.size()) {
		SetFreqAmplitude(_T("FilesweepOnTimer()"), ToHz(m_FreqAmpls[m_FreqAmplsI].frequency), ToInt(m_FreqAmpls[m_FreqAmplsI].amplitude));
		m_CurrentFrequency = m_FreqAmpls[m_FreqAmplsI].frequency;
		m_CurrentAmplitude = m_FreqAmpls[m_FreqAmplsI].amplitude;
		UpdateData(FALSE);
	}
	else {
		FilesweepStop();
		m_FilesweepStart = FALSE;
		UpdateData(FALSE);
	}
}

bool CUSBTG44ADlg::LoadFile(LPCTSTR filePath)
{

	CStdioFile file(filePath, CFile::modeRead | CFile::shareDenyNone);
	CString line;
	file.ReadString(line); // Title

	FreqAmpl fa;
	while(file.ReadString(line)) {

		int pos = 0;

		fa.frequency = ReadCell(line, pos);
		if (fa.frequency == _T("")) {
			break;
		}
		
		fa.amplitude = ReadCell(line, pos);

		m_FreqAmpls.push_back(fa);
	}

	if (m_FreqAmpls.size() > 0) {
		return true;
	}
	
	return false;
}


int Initialize(CString functionName)
{
	int err = TGAPI_Initialize();
//	gLog.Write(functionName, _T("TGAPI_Initialize() = %d"), err);

	return err;
}

bool ReadCalData(CString functionName)
{
	// If TGAPI_ReadCalData() takes more then 100 ms then the device have been successfully found, else returns false;
	DWORD t1 = ::GetTickCount();
	TGAPI_ReadCalData();
//	gLog.Write(functionName, _T("TGAPI_ReadCalData()"));

	if (::GetTickCount() - t1 < 100) {
		return false;
	}

	return true;
}

// Frequency and amplitude must be Integer
int SetFreqAmplitude(CString functionName, LONGLONG frequency, int amplitude)
{
	int err = TGAPI_SetFreqAmplitude(static_cast<float>(frequency), static_cast<float>(amplitude));
//	gLog.Write(functionName, _T("TGAPI_SetFreqAmplitude(%lld, %d) = %d"), frequency, amplitude, err);

	return err;
}
