
// USB-TG44ADlg.h : header file
//

#pragma once



// CUSBTG44ADlg dialog
class CUSBTG44ADlg : public CDialogEx
{
public:
	struct FreqAmpl {
		CString frequency;
		CString amplitude;
	};
	typedef std::vector<FreqAmpl> FreqAmpls;

// Construction
public:
	CUSBTG44ADlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_USBTG44A_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

	afx_msg void OnClose();
	afx_msg void OnTimer(UINT_PTR nIDEvent);

	afx_msg void OnBnClickedSingletoneApply();
	afx_msg void OnBnClickedFreqsweepStart();
	afx_msg void OnBnClickedAmplsweepStart();
	afx_msg void OnBnClickedFilesweepStart();
	afx_msg void OnBnClickedFilesweepOpen();

protected:
	void InitControls();
	void SaveControls();
	void FreqsweepStop();
	void AmplsweepStop();
	void FilesweepStop();
	void FreqsweepOnTimer();
	void AmplsweepOnTimer();
	void FilesweepOnTimer();
	bool LoadFile(LPCTSTR filePath);
	bool FileWasLoaded() { return m_FreqAmpls.size() > 0; }

protected:
	// Use to convert from MHz to Hz
	static const float MHZ;
	// Timers:
	static const UINT_PTR scFreqsweepTimerId = 1;
	static const UINT_PTR scAmplsweepTimerId = 2;
	static const UINT_PTR scFilesweepTimerId = 3;

private:
	CString m_CurrentFrequency;
	CString m_CurrentAmplitude;

	CString m_SingletoneFrequency; //   CString   MHz.
	CString m_SingletoneAmplitude; //   CString   dBm

	CString m_FreqsweepStartFrequency;
	CString m_FreqsweepStopFrequency;
	CString m_FreqsweepStepFrequency;
	UINT m_FreqsweepStepTime;
	CString m_FreqsweepAmplitude;
	BOOL m_FreqsweepStart;
	BOOL m_FreqsweepLoop;

	CString m_AmplsweepStartAmplitude;
	CString m_AmplsweepStopAmplitude;
	CString m_AmplsweepStepAmplitude;
	UINT m_AmplsweepStepTime;
	CString m_AmplsweepFrequency;
	BOOL m_AmplsweepStart;
	BOOL m_AmplsweepLoop;

	CString m_FilesweepFilename;
	UINT m_FilesweepStepTime;
	BOOL m_FilesweepStart;
	BOOL m_FilesweepLoop;

	UINT_PTR m_TimerId;

private:
	FreqAmpls m_FreqAmpls;
	UINT m_FreqAmplsI;
};

int Initialize(CString functionName);
bool ReadCalData(CString functionName);
int SetFreqAmplitude(CString functionName, LONGLONG frequency, int amplitude);
