#include "stdafx.h"

// Use to convert from MHz to Hz
static const double MHZ = 1000000;

double ToMHz(LONGLONG valueInHz) {
	return double(valueInHz) / MHZ;
}

LONGLONG ToHz(double valueInMHz) {
	return static_cast<LONGLONG>(valueInMHz * MHZ);
}

// Converts from floating point number stored in CString
// You can use point as well as comma delimiter.
LONGLONG ToHz(CString strInMHz) {
	strInMHz.Replace(_T(','), _T('.'));
	return ToHz(_ttof(strInMHz));
}

int ToInt(CString str) {
	return static_cast<int>(_ttof(str));
}

CString ToString(float value)
{
	CString str;
	str.Format(_T("%.10f"), value);
	if (str.GetLength() == 0) {
		return _T("");
	}

	int pointPos = str.Find(_T('.'));
	if (pointPos == -1) {
		return str;
	}

	int deleteNullsFrom = -1;
	for(int i = str.GetLength() - 1; i > pointPos; i--) {
		if (str[i] == '0') {
			deleteNullsFrom = i;
		}
		else {
			break;
		}
	}

	if (deleteNullsFrom != -1) {
		str.Delete(deleteNullsFrom, str.GetLength() - deleteNullsFrom);
	}

	return str;
}

CString ReadCell(CString& line, int& pos)
{
	if (line[pos] == _T(';')) {
		pos++;
		return _T("");
	}
	return line.Tokenize(_T(";"), pos);
}

